################################################################################
####                    Copyright (C) 2017 Joseph McKeown                  #####
####                                                                       #####
#### This program is free software: you can redistribute it and/or modify  #####
#### it under the terms of the GNU General Public License as published by  #####
#### the Free Software Foundation, either version 3 of the License, or     #####
#### (at your option) any later version.                                   #####
####                                                                       #####
#### This program is distributed in the hope that it will be useful,       #####
#### but WITHOUT ANY WARRANTY; without even the implied warranty of        #####
#### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #####
#### GNU General Public License for more details.                          #####
####                                                                       #####
#### You should have received a copy of the GNU General Public License     #####
#### along with this program.  If not, see <http://www.gnu.org/licenses/>. #####
################################################################################

print "                   Copyright (C) 2017 Joseph McKeown               "
print ""
print "This program is free software: you can redistribute it and/or modify"
print "it under the terms of the GNU General Public License as published by"
print "the Free Software Foundation, either version 3 of the License, or"
print "(at your option) any later version."
print ""
print "This program is distributed in the hope that it will be useful,"
print "but WITHOUT ANY WARRANTY; without even the implied warranty of"
print "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the"
print "GNU General Public License for more details."
print ""
print "You should have received a copy of the GNU General Public License"
print "along with this program.  If not, see <http://www.gnu.org/licenses/>."
print ""
print "---------------------------------------------------------------------"
print ""

# Standard imports
import cv2
import numpy as np;

# Read image(s)
im = cv2.imread(raw_input("Focal Image Filepath: "), cv2.IMREAD_GRAYSCALE)
ValidInput = False
while ValidInput == False:
    Use_GRAD = raw_input("Use a gradient image? ")
    if Use_GRAD.lower() == "true" or Use_GRAD.lower() == "t":
        imgrad = cv2.imread(raw_input("Gradient Focal Image Filepath: "), cv2.IMREAD_GRAYSCALE)
        ValidInput = True
    elif Use_GRAD.lower() == "false"  or Use_GRAD.lower() == "f":
        ValidInput = True
    else:
        print "Please enter only True or False."
# Setup SimpleBlobDetector parameters.
params = cv2.SimpleBlobDetector_Params()

# Change thresholds
params.minThreshold = 10;
params.maxThreshold = 200;

# Filter by Area.
params.filterByArea = True
params.minArea = int(raw_input("Minimum Area of a Cell (pixels): "))
params.maxArea = int(raw_input("Maximum Area of a Cell (pixels): "))

# Filter by Circularity
params.filterByCircularity = True
params.minCircularity = 0.7

# Filter by Convexity
params.filterByConvexity = True
params.minConvexity = 0.7

# Create a detector with the parameters
ver = (cv2.__version__).split('.')
if int(ver[0]) < 3 :
    detector = cv2.SimpleBlobDetector(params)
else : 
    detector = cv2.SimpleBlobDetector_create(params)

# Detect blobs.
keypoints = detector.detect(im)
if Use_GRAD.lower() == "true" or Use_GRAD.lower() == "t":
    keypoints_grad = detector.detect(imgrad)

# Draw detected blobs as circles.
# cv2.DRAW_MATCHES_FLAGS_DRAW_RICH_KEYPOINTS ensures the size of the circle corresponds to the size of blob
im_with_keypoints = cv2.drawKeypoints(im, keypoints, np.array([]), (0,0,255), cv2.DRAW_MATCHES_FLAGS_DRAW_RICH_KEYPOINTS)
if Use_GRAD.lower() == "true" or Use_GRAD.lower() == "t":
    im_with_both_keypoints = cv2.drawKeypoints(im_with_keypoints, keypoints_grad, np.array([]), (255,0,0), cv2.DRAW_MATCHES_FLAGS_DRAW_RICH_KEYPOINTS)

# Show keypoints
    print "Please count the number of overlapping blue and red circles, then press any key to continue."
    cv2.imshow("Keypoints", im_with_both_keypoints)
    cv2.waitKey(0)
else:
    cv2.imshow("Keypoints", im_with_keypoints)

# Print number of cells counted in each image, then ask for user
# input to remove the number of overlaps from the total count.
if Use_GRAD.lower() == "true" or Use_GRAD.lower() == "t":
    print "There were %s blobs detected in the focal plane and %s detected in the gradient focal plane."%(len(keypoints),len(keypoints_grad))
    Offset = int(raw_input("How many are overlapping? "))
    print "The total number of blobs detected was, therefore, %d. Press any key to exit."%(len(keypoints)+len(keypoints_grad)-Offset)
    cv2.waitKey(0)
    cv2.destroyAllWindows()
else:
    print "There were %s blobs detected in the focal plane. Press any key to exit."%(len(keypoints))
    cv2.waitKey(0)
    cv2.destroyAllWindows()
